﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataErrorInfoProblem2
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            bool aShowProblem = true;
            
            this.xamDataGrid1.FieldLayoutSettings.AutoGenerateFields = !aShowProblem;
            this.xamDataGrid1.DataSource = new CRecord[] { this.Record };


        }

        private CRecord Record = new CRecord();

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            string aNoError = String.Empty;
            if (this.Record.Error == aNoError)
            {
                this.Record.Error = "TestError";
            }
            else
            {
                this.Record.Error = aNoError;
            }
        }
    }

    public class CRecord : System.ComponentModel.IDataErrorInfo, System.ComponentModel.INotifyPropertyChanged
    {
        int myproperty;
        public int MyProperty
        {
            get
            {
                return myproperty;
            }
            set
            {
                myproperty = value;
                if (PropertyChanged != null)
                {
                    this.PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs("MyProperty"));
                }
            }
        }

        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

        private string ErrorM = "TestError";
        public string Error
        {
            set
            {
                this.ErrorM = value;
                if (null != this.PropertyChanged)
                {
                    this.PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(""));
                }
            }
            get
            {
                return this.ErrorM;
            }
        }

        public string this[string aName]
        {
            get
            {
                return string.Empty;
            }
        }
    }


}
